import logger
import uvicorn
from fastapi import FastAPI

from handler import car, health

# 禁用 redoc
app = FastAPI(docs_url="/docs", redoc_url=None)

app.include_router(health.router)
app.include_router(car.router)


@app.on_event("startup")
async def startup():
    logger.logger.info("服务启动")


@app.on_event("shutdown")
async def shutdown():
    logger.logger.info("服务关闭")


if __name__ == '__main__':
    uvicorn.run("main:app", host="0.0.0.0", port=5000, reload=True)
